/**********************************************
*  t\퐧䃉Cu(LCD (SC1602BS-B) 4bit[hŎgp)
*  szu3.3V쓮LCD(SC1602BBWB-XA-LB-G)ɂΉ
*  ֐͈ȉ
* void lcd_init();				----- (s͏o̓[hɐݒ肵Ă)
* void lcd_cmd(cmd);			----- R}ho
* void lcd_data(chr);			----- P\o
* void lcd_clear();				----- S
* void lcd_second_line();		----- 2sڂֈړ
* void lcd_num1(num);			----- unsigned char^̐0`9,+,-\
* void lcd_num(num);			----- signed int^̐̕\
* void lcd_num_dig(num, digit);	----- signed int^̐̕\(w,0̂ƂtLVu)
* void lcd_num16(num);			----- unsigned int^̐16iŕ\
* void lcd_num2(num);			----- unsigned int^̐2iŕ\
* void lcd_cur_home();			----- J[\Homeֈړ
* void lcd_print_text(char *);	----- \(:lcd_print_text("Hello PIC!");
************************************************/

/********** t\Cuݒ ***********
#define 	lcd_DataBit4	PORTBbits.RB4
#define 	lcd_DataBit5	PORTBbits.RB5
#define 	lcd_DataBit6	PORTBbits.RB6
#define 	lcd_DataBit7	PORTBbits.RB7
#define		lcd_e			PORTBbits.RB2	//EnableM̃sw(̃s̓v_EĂ)
#define		lcd_rs			PORTBbits.RB3	//RSM̃sw
#include	<lcd_lib_dspic30F4012.c>		//define<lcd_lib_dspic30F4012.c>CN[h
************************************************/

//delay֐gp
#include <libpic30.h>

/********* f[^o̓Tu֐ **************/
void lcd_out(unsigned char code, unsigned char flag)
{
	//4rbg
	code = code << 1;
	lcd_DataBit7 = SRbits.C;
	code = code << 1;
	lcd_DataBit6 = SRbits.C;
	code = code << 1;
	lcd_DataBit5 = SRbits.C;
	code = code << 1;
	lcd_DataBit4 = SRbits.C;

	if (flag == 0)
		lcd_rs = 1;		//\f[^̏ꍇ
	else
		lcd_rs = 0;		//R}hf[^̏ꍇ
	__delay_us(1);		//NOP
	lcd_e = 1;			//strobe out
	__delay_us(2);		//NOP
	lcd_e = 0;			//reset strobe
	__delay_us(1);		//NOP
}

/******** P\֐ **********/
void lcd_data(unsigned char asci)
{
	lcd_out(asci, 0);		//ʂSrbgo
	lcd_out(asci << 4, 0);	//ʂSrbgo
	__delay_us(100);		//50usȏwait
}

/******** R}ho͊֐ ********/
void lcd_cmd(unsigned char cmd)
{
	lcd_out(cmd, 1);			//ʂSrbgo
	lcd_out(cmd << 4, 1);		//ʂSrbgo
	if((cmd & 0x03) != 0){
		__delay_ms(5);			//Clear_DisplayClear At HomêƂ
	} else {
		__delay_us(200);		//̑̏ꍇ(҂ԂႤ)
	}
}

/********** S֐ *********/
void lcd_clear()
{
	lcd_cmd(0x01);			//R}ho
	__delay_ms(15);
}

/******** ֐ *********/
void lcd_init()
{
	__delay_ms(41);		//wait more than 15ms(40ms) after Vcc rises to 4.5V(2.7V)
	lcd_out(0x30, 1);		//8bit mode set
	__delay_ms(5);		//wait more than 4.1ms
	lcd_out(0x30, 1);		//8bit mode set
	__delay_us(500);		//wait more than 100us
	lcd_out(0x30, 1);		//8bit mode set
	__delay_ms(1);
	lcd_out(0x20, 1);		//4bit mode set
	__delay_ms(1);

	lcd_cmd(0x2E);		//DL=0 4bit mode
	__delay_us(1);
	lcd_cmd(0x80);		//display off C=D=B=0
	__delay_us(1);
	lcd_cmd(0x0D);		//display on C=D=1 B=0
	__delay_us(1);
	lcd_cmd(0x06);		//entry I/D=1 S=0
	__delay_us(1);
	lcd_cmd(0x02);		//cursor home
	__delay_us(1);

	lcd_clear();
}

/******** 2sڂփAhXړ *********/
#define		lcd_second_line()	lcd_cmd(0xC0)

/******** 3sڂփAhXړ(4sLCD̂) *********/
#define		lcd_third_line()	lcd_cmd(0x94)

/******** 4sڂփAhXړ(4sLCD̂) *********/
#define		lcd_fourth_line()	lcd_cmd(0xD4)


/******** J[\HomeɈړ *********/
#define		lcd_cur_home()		lcd_cmd(0x02)


/******** 1o *********/
void lcd_num1(unsigned char lcd_number)
{
	unsigned char i;
	switch (lcd_number)
	{
	case 0:
		i = 0x30;
		break;
	case 1:
		i = 0x31;
		break;
	case 2:
		i = 0x32;
		break;
	case 3:
		i = 0x33;
		break;
	case 4:
		i = 0x34;
		break;
	case 5:
		i = 0x35;
		break;
	case 6:
		i = 0x36;
		break;
	case 7:
		i = 0x37;
		break;
	case 8:
		i = 0x38;
		break;
	case 9:
		i = 0x39;
		break;

	case 10:
		i = 0x41;	// "A"
		break;
	case 11:
		i = 0x42;	// "B"
		break;
	case 12:
		i = 0x43;	// "C"
		break;
	case 13:
		i = 0x44;	// "D"
		break;
	case 14:
		i = 0x45;	// "E"
		break;
	case 15:
		i = 0x46;	// "F"
		break;

	default:
		i = 0x3F;	//"H"\
		break;
	}
	lcd_data(i);
}

void lcd_num(signed int lcd_number)
{
	unsigned char num[5], digits = 0, buf;
	signed int i = lcd_number;
	if (lcd_number < 0)
	{
		i = 0 - i;		//Βl
		lcd_data(0x2D);	//"-"\
	}
	if ( (i / 10000) != 0){
		digits = 5;
	} else if ( (i / 1000) != 0){
		digits = 4;
	} else if( (i / 100) != 0){
		digits = 3;
	} else if( (i / 10) != 0){
		digits = 2;
	} else {
		digits = 1;
	}
	buf = digits;
	while (buf != 0)
	{
		num[buf - 1] = i % 10;
		i /= 10;
		buf--;
	}
	//buf0ɂȂĂ
	
	while(buf < digits)
	{
		lcd_num1( num[buf] );
		buf++;
	}
}

void lcd_num_dig(signed int lcd_number, char digit)
{
	unsigned char num[5], digits = 0, buf;
	char buf_dig = digit;
	signed int i = lcd_number;
	
	if( (digit < 0) || (digit >= 17) )
	{
		lcd_data(0x3F);		// "?"\(G[)
		return;
	}
	
	if (lcd_number < 0)
	{
		i = 0 - i;			//Βl
		lcd_data(0x2D);		//"-"\
		if(digit != 0)
			buf_dig--;
	}
	if ( (i / 10000) != 0){
		digits = 5;
	} else if ( (i / 1000) != 0){
		digits = 4;
	} else if( (i / 100) != 0){
		digits = 3;
	} else if( (i / 10) != 0){
		digits = 2;
	} else {
		digits = 1;
	}
	buf = digits;
	
	while (buf != 0)
	{
		num[buf - 1] = i % 10;
		i /= 10;
		buf--;
	}
	//buf0ɂȂĂ
	
	if(digit == 0)
	{
		while(buf < digits)
		{
			lcd_num1( num[buf] );
			buf++;
		}
	}
	else
	{
		while(buf_dig > digits)
		{
			lcd_data(0x20);		//Xy[X
			buf_dig--;
		}
		while(buf < buf_dig)
		{
			lcd_num1( num[buf] );
			buf++;
		}
	}
}

void lcd_num16(unsigned int lcd_number)
{
	unsigned int buf_lcdnum16 = lcd_number;
	lcd_num1( (buf_lcdnum16 >> 12) & 0x000F);
	lcd_num1( (buf_lcdnum16 >>  8) & 0x000F);
	lcd_num1( (buf_lcdnum16 >>  4) & 0x000F);
	lcd_num1( (buf_lcdnum16 >>  0) & 0x000F);
}

void lcd_num2(unsigned int lcd_number)
{
	unsigned int buf_lcdnum2 = lcd_number;
	signed char i = 0;
	for(i = 15; i >= 0; i--)
		lcd_num1( (buf_lcdnum2 >> i) & 0x0001);
}

void lcd_print_text(char *char_array)
{
	while(*char_array != '\0')
	{
		lcd_data(*char_array);	//|C^ŎAhX̃f[^
		char_array++;			//|C^̒l₵Ď̃f[^
	}
}

