/*
* vOXg4
* A/Dϊ蓮ōsALCDɂ̒lo͂vO
* dsPIC30F4012
*/

#define FCY 29480000 / 4    //NbN
#include <p30F4012.h>

// LCDsݒ
#define 	lcd_DataBit4	PORTDbits.RD0
#define 	lcd_DataBit5	PORTDbits.RD1
#define 	lcd_DataBit6	PORTCbits.RC13
#define 	lcd_DataBit7	PORTCbits.RC14
#define		lcd_e		PORTEbits.RE8	//EnableM̃sw
#define		lcd_rs		PORTCbits.RC15	//RSM̃sw
#include	<lcd_lib_dspic30F4012.c>

//RtBM[V
_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_ON & BORV20 & PWRT_OFF & MCLR_EN);
_FGS(CODE_PROT_OFF);

//ADϊli[pϐ
int adc_value_AN0 = 0, adc_voltage = 0;

//^C}1荞ݏ
void __attribute__ ((__interrupt__,auto_psv)) _T1Interrupt(void){
	IFS0bits.T1IF=0;                //^C}1荞݃tONA
	ADCON1bits.SAMP = 1;             //ADϊJn
	while (ADCON1bits.DONE == 0){}   //ADϊI܂NOP
	adc_value_AN0 = ADCBUF0;

	static unsigned char lcd_clear_cnt = 0;
	if (lcd_clear_cnt > 10){
		lcd_clear();
		lcd_clear_cnt = 0;
	}
	lcd_clear_cnt++;

	lcd_cur_home();
	lcd_num(adc_value_AN0);
	lcd_second_line();

	adc_voltage = (long)5 * 100 * (adc_value_AN0 + 1) / 1024;
	lcd_num(adc_voltage / 100);
	lcd_print_text(".");
	lcd_num(adc_voltage % 100);
	lcd_data('V');
}

//C
int main(void){
	//IO|[gݒ
	TRISC = 0x0000;
	PORTC = 0x0000;
	TRISD = 0x0000;
	PORTD = 0x0000;
	TRISE = 0x0000;
	PORTE = 0x0000;

	// LCD
	lcd_init();

	//ADϊpϐ
	ADCON1 = 0xA0E0;
		/* ADCON1
		* ADCON, IDLEADC~, o͂͐f[^,
		* ϊgK, Tvsgp, TvO蓮Jn
		*/
	ADCON2 = 0x0000;
		/* ADCON2
		* t@XVdd/Vss, XL͂Ȃ, CH0̂ݕϊ,
		* 1ADCɊ荞, MUX Agp
		*/
	ADCON3 = 0x0110;
		/* ADCON3
		* Tv^C1Tad, VXeNbN, ϊNbN8Tcy
		*/
	ADCHS  = 0x0000;
		/* ADCHS
		* CH1~3͂̕Vref, CH1~3̐͂AN0~2,
		* CH0͂̕Vref, CH0̐͂AN0
		*/
	ADPCFG = 0x0000;    //AN0~AN5͑SăAiO̓[h
	ADCSSL = 0x0000;    //̓XL͑SăXLbv

	//^C}1E^C}1荞ݐݒ
	PR1 = 100 * (FCY /1000 / 256);    //^C}1̎ݒ
	T1CON = 0xA030;
		/* T1CON
		* ^C}ON, IDLE^C}~, Q[g^CݎZ,
		* vXP[1:256, NbNgp
		*/
	IEC0bits.T1IE = 1;  //^C}1荞݋
	IPC0bits.T1IP = 5;  //^C}1D惌xݒ

	SRbits.IPL = 2;     //CPU荞ݗD惌xݒ
	DISICNT = 0x0000;   //S荞݂
	while(1){
	}
	return 0;
}
