/*
* vOXg8
* SPI TvvO(X[u)
* gp}CRFdsPIC30F4012 @ 29.48MHz
*/

#define FCY 29480000 / 4    //NbN
#include <p30F4012.h>

// LCDsݒ
//RE8SSsƂĎgLCDEnablesRE5ɕύXĂ܂
#define 	lcd_DataBit4	PORTDbits.RD0
#define 	lcd_DataBit5	PORTDbits.RD1
#define 	lcd_DataBit6	PORTCbits.RC13
#define 	lcd_DataBit7	PORTCbits.RC14
#define		lcd_e		PORTEbits.RE5	//EnableM̃sw
#define		lcd_rs		PORTCbits.RC15	//RSM̃sw
#include	<lcd_lib_dspic30F4012.c>

//RtBM[V
_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_ON & BORV20 & PWRT_OFF & MCLR_EN);
_FGS(CODE_PROT_OFF);

//vg^Cv錾
void SPI_master_init(void);
void SPI_slave_init(void);

//O[oϐ
int SPI_rcv = 0;
int SPI_num = 0;

//C
int main(void) {
	
	// I/O|[g̏ݒ
	TRISBbits.TRISB2 = 1;
	TRISC = 0x0000;
	TRISD = 0x0000;
	TRISE = 0x0000;
	PORTE = 0x0000;
	
	// LCD
	lcd_init();

	// SPIX[u
	SPI_slave_init();
	
	
	SRbits.IPL = 1; //CPU荞ݗD惌xݒ
	DISICNT = 0x0000; //S荞݂
	
	while (1) {
		
		//LCD
		lcd_cur_home();
		lcd_num_dig(SPI_rcv, 5);
	}
	return 0;
}

//SPI荞ݏ
void __attribute__((__interrupt__, auto_psv)) _SPI1Interrupt(void) {
	
	IFS0bits.SPI1IF = 0;		//SPI荞݃tONA
	
	SPI_rcv = SPI1BUF;			//Mf[^ǂݍ
	__delay_us(10);
	
	SPI_num--;
	SPI1BUF = SPI_num;
}

void SPI_master_init(void)
{
	IFS0bits.SPI1IF = 0;		//SPI荞݃tONA
	IEC0bits.SPI1IE = 1;		//SPI荞݋
	IPC2bits.SPI1IP = 6;		//SPI荞ݗD惌xݒ
	
	SPI1CONbits.MODE16 = 1;		//]Pʂ16bit
	SPI1CONbits.MSTEN = 1;		//}X^[[h
	SPI1CONbits.FRMEN = 0;		//t[SPI
	SPI1CONbits.DISSDO = 0;		//SDOSPIW[Ŏgp
	SPI1CONbits.SMP = 0;		//f[^o͎Ԃ̒œ̓f[^Tv
	SPI1CONbits.CKE = 1;		//NbNGbWI
	SPI1CONbits.CKP = 0;		//NbNɐ
	SPI1CONbits.SPRE = 0;		//2vXP[8:1
	SPI1CONbits.PPRE = 0;		//1vXP[64:1
	
	SPI1STATbits.SPIROV = 0;	//I[o[t[Ȃ
	SPI1STATbits.SPIEN = 1;		//SPIW[L
}

void SPI_slave_init(void)
{
	IFS0bits.SPI1IF = 0;		//SPI荞݃tONA
	IEC0bits.SPI1IE = 1;		//SPI荞݋
	IPC2bits.SPI1IP = 6;		//SPI荞ݗD惌xݒ
	
	SPI1CONbits.MODE16 = 1;		//]Pʂ16bit
	SPI1CONbits.MSTEN = 0;		//X[u[h
	SPI1CONbits.FRMEN = 0;		//t[SPI
	SPI1CONbits.DISSDO = 0;		//SDOSPIW[Ŏgp
	SPI1CONbits.SMP = 0;		//f[^o͎Ԃ̒œ̓f[^Tv
	SPI1CONbits.CKE = 1;		//NbNGbWI
	SPI1CONbits.SSEN = 1;		//SSsgp
	SPI1CONbits.CKP = 0;		//NbNɐ
	
	SPI1STATbits.SPIROV = 0;	//I[o[t[Ȃ
	SPI1STATbits.SPIEN = 1;		//SPIW[L
}

