/*
* ^PWMTvvO
* ADϊʂPWMpX̃f[eBςvO
* dsPIC30F4012 @ 29.48MHz
*/

#define FCY 29480000 / 4    //NbN
#include <p30F4012.h>

// LCDsݒ
#define 	lcd_DataBit4	PORTDbits.RD0
#define 	lcd_DataBit5	PORTDbits.RD1
#define 	lcd_DataBit6	PORTCbits.RC13
#define 	lcd_DataBit7	PORTCbits.RC14
#define		lcd_e		PORTEbits.RE8	//EnableM̃sw
#define		lcd_rs		PORTCbits.RC15	//RSM̃sw
#include	<lcd_lib_dspic30F4012.c>

//RtBM[V
_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_ON & BORV20 & PWRT_OFF & MCLR_EN);
_FGS(CODE_PROT_OFF);

//vg^Cv錾
void __attribute__ ((__interrupt__,auto_psv)) _ADCInterrupt(void);
void __attribute__ ((__interrupt__,auto_psv)) _T1Interrupt(void);

//C֐
int main(void){
	//IO|[g̏ݒ
	TRISC = 0x0000;
	PORTC = 0x0000;
	TRISD = 0x0000;
	PORTD = 0x0000;
	TRISEbits.TRISE8 = 0;
	PORTEbits.RE8 = 0;

	// LCD
	lcd_init();

	//^C}1E荞ݐݒ
	PR1 = 300 * ( FCY /1000 / 256);    //^C}1ݒ
	T1CON = 0xA030;     //vXP[1:256
	IEC0bits.T1IE = 1;  //^C}1荞݋
	IPC0bits.T1IP = 4;  //^C}1D惌xݒ

	//ADϊE荞ݐݒ
	ADCON1 = 0xA064;
	/* ADCON1
	* ADCON, IDLEADC~, o͂͐f[^,
	* PWMC^[oAD荞, Tvsgp, TvO
	*/
	ADCON2 = 0x0000;
	/* ADCON2
	* t@XVdd/Vss, XL͂Ȃ, CH0݂̂ϊ,
	* 1ADCɊ荞, MUX Agp
	*/
	ADCON3 = 0x0110;    //1Tad, VXeNbN, ϊNbN8Tcy
	ADCHS  = 0x0000;    //ADϊ`lݒ(CH0AN0)
	ADPCFG = 0x0000;    //AN0~AN5͑SăAiO̓[h
	ADCSSL = 0x0000;    //̓XL͑SăXLbv
	IPC2bits.ADIP = 5;  //ADϊD惌xݒ
	IEC0bits.ADIE = 1;  //ADϊ荞݋

	//PWMݒ
	OVDCON = 0x0010;
	/* OVDCON ݒ
	* 1L~3H܂őSPORT,
	* PORTs3L̂High
	*/
	PDC1 = 500;      //f[eB
	PDC2 = 500;
	PWMCON1 = 0x0C33;
	/* PWMCON1
	* PWMsyAPWM1PWM2^
	* 2H, 2L, 1H, 1LPWM(ȊOPORTs)
	*/
	PWMCON2 = 0x0000;
	/* PWMCON2
	* CxggK|XgXP[1:1, TcyEŏo̓I[o[Ch
	* f[eBEWX^̍XVL
	*/
	PTPER = 1000;       //PWM^Cx[X(15bit) ȒP̂1000ɐݒ
	DTCON1 = 0x0010;
	/* DTCON1 fbh^Cݒ
	* fbh^CjbgNbN1Tcy, fbh^Cl16
	* ăfbh^C2.16[?s] @ 29.48MHz
	*/
	SEVTCMP = 0x0000;   //CxgrWX^
	//PTCON = 0xA002;   //PWM3685Hz
	PTCON = 0xA006;
	/* PTCON
	* PWMI, IDLE~, ^Cx[X|XgXP[1:1,
	* ^Cx[X̓NbN1:4, Abv_EJEg[h
	*/
	// PWM͖921[Hz] @ PTPER=1000, ^Cx[X|XgXP[1:1, ^Cx[X̓NbN1:4, 29.48MHz

	while(1){
	}
}

void __attribute__ ((__interrupt__,auto_psv)) _ADCInterrupt(void){
	//ʏpϐ
	unsigned int result;
	//荞݃tONA
	IFS0bits.ADIF=0;

	//f[^
	result = ADCBUF0;	//(0?1023)͂̂܂resultɑ
	if(result > 990)
		result = 990;
	if(result < 10)
		result = 10;

	OVDCON = 0x0F00;
	/* OVDCON ݒ
	* 2H, 2L, 1H, 1LPWM,
	* PORTs͑SLow
	*/

	PDC1 = result;
	PDC2 = 1000 - result;
}

//^C}1荞ݏ
void __attribute__ ((__interrupt__,auto_psv)) _T1Interrupt(void){
	IFS0bits.T1IF=0;    //荞݃tONA

	//LCD\
	lcd_clear();
	int buf_pdc1, buf_pdc2, speed;
	buf_pdc1 = PDC1;
	buf_pdc2 = PDC2;

	lcd_print_text("D1:");
	lcd_num(buf_pdc1);
	lcd_print_text(", D2:");
	lcd_num(buf_pdc2);
	lcd_second_line();

	if(buf_pdc1 > buf_pdc2)
	{
		speed = (buf_pdc1 - buf_pdc2) / 10;
		lcd_print_text("CW  ");
	}
	else
	{
		speed = (buf_pdc2 - buf_pdc1) / 10;
		lcd_print_text("CCW ");
	}
	lcd_num(speed);
	lcd_print_text("%");
}
