/*
* QEI TvvO
* [^[GR[_(QEA, QEB̂)󂯎\vO
* EC202A100AɂēmFς
* gp}CRFdsPIC30F4012 @ 29.48MHz
*/

#define FCY 29480000 / 4    //NbN
#include <p30F4012.h>

// LCDsݒ
#define 	lcd_DataBit4	PORTDbits.RD0
#define 	lcd_DataBit5	PORTDbits.RD1
#define 	lcd_DataBit6	PORTCbits.RC13
#define 	lcd_DataBit7	PORTCbits.RC14
#define		lcd_e		PORTEbits.RE8	//EnableM̃sw
#define		lcd_rs		PORTCbits.RC15	//RSM̃sw
#include	<lcd_lib_dspic30F4012.c>

#define ENCODER_PULSE 100		//1]̃pX

//RtBM[V
_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_ON & BORV20 & PWRT_OFF & MCLR_EN);
_FGS(CODE_PROT_OFF);

//vg^Cv錾
void QEI_init(void);

//O[oϐ
signed int QEI_interrupt = 0;

//C
int main(void) {
	
	// I/O|[g̏ݒ
	TRISC = 0x0000;
	TRISD = 0x0000;
	TRISE = 0x0000;
	PORTE = 0x0000;
	
	// LCD
	lcd_init();

	// QEI
	QEI_init();
	
	
	SRbits.IPL = 1; //CPU荞ݗD惌xݒ
	DISICNT = 0x0000; //S荞݂
	
	while (1) {
		lcd_cur_home();
		
		lcd_print_text("ѷ:");
		if(QEICONbits.UPDN)
			lcd_print_text("+, ");
		else
			lcd_print_text("-, ");
		
		lcd_print_text("POSCNT:");
		lcd_num_dig(POSCNT, 3);
		
		lcd_second_line();
		
		lcd_print_text("ݽ:");
		lcd_num_dig(QEI_interrupt, 4);
	}
	return 0;
}

// QEI荞ݏ
void __attribute__((__interrupt__, auto_psv)) _QEIInterrupt(void) {
	//荞݃tONA
	IFS2bits.QEIIF = 0;
	
	if(QEICONbits.UPDN)
		QEI_interrupt++;
	else
		QEI_interrupt--;
}

void QEI_init(void)
{
	ADPCFG |= 0x0030;	//RB4(QEA), RB5(QEB)fW^o̓[h
	MAXCNT = ENCODER_PULSE * 2;	//MAXCNTݒ(X2[hȂ̂Ń[^[GR[_̃pX2{1])
	QEICONbits.QEIM = 0;		//QEIW[OFF
	QEICONbits.CNTERR = 0;		//JEgG[Ȃ
	QEICONbits.QEISIDL = 0;		//IDLEp
	QEICONbits.SWPAB = 0;		//QEAQEBւȂ
	QEICONbits.PCDOUT = 0;		//ʏ̓o̓s
	QEICONbits.POSRES = 1;		//CfbNXpXŃZbgȂ
	
	DFLTCONbits.CEID = 1;		//|WVJEgG[荞ݖ
	DFLTCONbits.QEOUT = 1;		//fW^tB^L
	DFLTCONbits.QECK = 5;		//fW^tB^NbN1:64
	
	POSCNT = 0;
	QEICONbits.QEIM = 5;		//X2[h, MAXCNTvŃZbgE荞
	
	IEC2bits.QEIIE = 1;			//QEI荞݋
	IPC10bits.QEIIP = 5;		//QEI荞ݗD惌xݒ
}

