/*
* T[{[^ TvvO
* 4chA/DϊʂT[{[^̊pxςvO
* dsPIC30F4012 @ 29.48MHz
*/

#define FCY 29480000 / 4    //NbN
#include <p30F4012.h>

#define servo_num	4      //T[{[^̐
#define servo1		1
#define servo2		2
#define servo3		3
#define servo4		4
#define servo1pin	PORTEbits.RE0   // T[{1̃sԍ
#define servo2pin	PORTEbits.RE1
#define servo3pin	PORTEbits.RE2
#define servo4pin	PORTEbits.RE3

//RtBM[V
_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_ON & BORV20 & PWRT_OFF & MCLR_EN);
_FGS(CODE_PROT_OFF);

//vg^Cv錾
void __attribute__((__interrupt__, auto_psv)) _T1Interrupt(void);
void __attribute__((__interrupt__, auto_psv)) _T4Interrupt(void);
void __attribute__((__interrupt__, auto_psv)) _T5Interrupt(void);

unsigned char servoX_on = servo1; //Ԗڂ̃T[{̃pXMonɂ邩肷ϐ

// A/Dϊʂ̊i[pϐ
unsigned int result[servo_num] = {0, 0, 0, 0};

//C
int main(void) {
	// I/O|[g̏ݒ
	TRISE = 0x0000; //PORTE͑Sďo
	PORTE = 0x0000;

	//^C}1E荞ݐݒ
	PR1 = 100 * (FCY / 1000 / 64); //^C}3̎ݒ
	T1CON = 0xA020; //vXP[1:64
	IEC0bits.T1IE = 1; //^C}1荞݋
	IPC0bits.T1IP = 3; //^C}1荞ݗD惌xݒ

	//^C}4E荞ݐݒ
	PR4 = 20 * (FCY / 1000 / 8) / servo_num; //T[{̃pX(20ms)T[{Ŋ
	T4CON = 0xA010; //vXP[1:8, 16rbg^C}
	IEC1bits.T4IE = 1; //^C}4荞݋
	IPC5bits.T4IP = 4; //^C}4荞ݗD惌xݒ

	//^C}5E荞ݐݒ
	PR5 = 11055; //^C}5ݒ(1.5ms)
	T5CON = 0xA000; //vXP[1:1
	IEC1bits.T5IE = 0; //^C}5荞ݕs(^C}4ŋ)
	IPC5bits.T5IP = 5; //^C}5荞ݗD惌xݒ

	//ADϊE荞ݐݒ
	ADCON1 = 0xA0E0;
	/* ADCON1
	* ADCON, IDLEADC~, o͂͐f[^,
	* ϊgK, Tvsgp, TvO蓮Jn
	*/
	ADCON2 = 0x0000;
	/* ADCON2
	* t@XVdd/Vss, XL͂Ȃ, CH0̂ݕϊ,
	* 1ADCɊ荞, MUX Agp
	*/
	ADCON3 = 0x0110;
	/* ADCON3
	* Tv^C1Tad, VXeNbN, ϊNbN8Tcy
	*/
	ADCHS = 0x0000;
	/* ADCHS
	* CH1~3͂̕Vref, CH1~3̐͂AN0~2,
	* CH0͂̕Vref, CH0̐͂AN0
	*/
	ADPCFG = 0x0000; //AN0~AN5͑SăAiO̓[h
	ADCSSL = 0x0000; //̓XL͑SăXLbv

	SRbits.IPL = 1; //CPU荞ݗD惌xݒ
	DISICNT = 0x0000; //S荞݂

	while (1) {
	}
	return 0;
}

// ^C}1荞ݏ(ADϊ)
void __attribute__((__interrupt__, auto_psv)) _T1Interrupt(void) {
	IFS0bits.T1IF = 0; //^C}1荞݃tONA

	ADCON1 = 0xA0E0;		//ADϊW[gpJn
	ADCON2 = 0x0000;
	ADCON3 = 0x0110;
	ADCHS = 0x0000;			//AN0̕ϊ
	ADCON1bits.SAMP = 1;	//ADϊJn
	while (ADCON1bits.DONE == 0) {} //ADϊI܂NOP
	result[servo1 - 1] = ADCBUF0;
	ADCON1 = 0x0000;		//ADϊ~

	ADCON1 = 0xA0E0;		//ADϊW[gpJn
	ADCON2 = 0x0000;
	ADCON3 = 0x0110;
	ADCHS = 0x0001;			//AN0̕ϊ
	ADCON1bits.SAMP = 1;	//ADϊJn
	while (ADCON1bits.DONE == 0) {} //ADϊI܂NOP
	result[servo2 - 1] = ADCBUF0;
	ADCON1 = 0x0000;		//ADϊ~

	ADCON1 = 0xA0E0;		//ADϊW[gpJn
	ADCON2 = 0x0000;
	ADCON3 = 0x0110;
	ADCHS = 0x0002;			//AN0̕ϊ
	ADCON1bits.SAMP = 1;	//ADϊJn
	while (ADCON1bits.DONE == 0) {} //ADϊI܂NOP
	result[servo3 - 1] = ADCBUF0;
	ADCON1 = 0x0000;		//ADϊ~

	ADCON1 = 0xA0E0;		//ADϊW[gpJn
	ADCON2 = 0x0000;
	ADCON3 = 0x0110;
	ADCHS = 0x0003;			//AN0̕ϊ
	ADCON1bits.SAMP = 1;	//ADϊJn
	while (ADCON1bits.DONE == 0) {} //ADϊI܂NOP
	result[servo4 - 1] = ADCBUF0;
	ADCON1 = 0x0000;		//ADϊ~
}

// ^C}4荞ݏ(T[{[^̃pX/T[{)
void __attribute__((__interrupt__, auto_psv)) _T4Interrupt(void) {
	IFS1bits.T4IF = 0; //^C}4荞݃tONA

	IEC1bits.T5IE = 1;
	TMR5 = 0;       //^C}5JE^Zbg
	//eT[{̃pX̗オ蕝1`2ms
	PR5 = 7370;     // 1ms = 1 * (FCY /1000)

	switch (servoX_on) {
	case servo1:
		PR5 += 7370 * (long)result[servo1 - 1] >> 10;  // " >>10 "" /1024 "Ɠ
		servo1pin = 1; //T[{1̃pXグ
		servoX_on = servo2; //̓T[{2
		break;
	case servo2:
		PR5 += 7370 * (long) result[servo2 - 1] >> 10;
		servo2pin = 1; //T[{2̃pXグ
		servoX_on = servo3; //̓T[{3
		break;
	case servo3:
		PR5 += 7370 * (long) result[servo3 - 1] >> 10;
		servo3pin = 1; //T[{3̃pXグ
		servoX_on = servo4; //̓T[{4
		break;
	case servo4:
		PR5 += 7370 * (long) result[servo4 - 1] >> 10;
		servo4pin = 1; //T[{4̃pXグ
		servoX_on = servo1; //̓T[{1
		break;
	default: //G[
		servoX_on = servo1;
		break;
	}
	T5CONbits.TON = 1;
}

// ^C}5荞ݏ(eT[{[^̗オ蕝)
void __attribute__((__interrupt__, auto_psv)) _T5Interrupt(void) {
	//荞݃tONA
	IFS1bits.T5IF = 0;
	T5CONbits.TON = 0; //^C}5 OFF

	servo1pin = 0;      //2sȂƉ̂pXsɂȂ(͕s)
	servo1pin = 0;
	servo2pin = 0;
	servo3pin = 0;
	servo4pin = 0;
}
