/*
* K3 𓚗
* A/Dϊ̓TvOg2LED̓_ŎωvO
* AN2AN3gp
* dsPIC30F4012 @ 29.48MHz
*/

#define FCY 29480000 / 4    //NbN
#include <p30F4012.h>

//RtBM[V
_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_ON & BORV20 & PWRT_OFF & MCLR_EN);
_FGS(CODE_PROT_OFF);

//LED1_ŗppX쐬(^C}1荞ݏ)
void __attribute__ ((__interrupt__,auto_psv)) _T1Interrupt(void){
	IFS0bits.T1IF=0;    //荞݃tONA
	PORTE ^= (1 << 0);  //RE0̃rbg𔽓]
}

//LED2_ŗppX쐬(^C}2荞ݏ)
void __attribute__ ((__interrupt__,auto_psv)) _T2Interrupt(void){
	IFS0bits.T2IF=0;    //荞݃tONA
	PORTE ^= (1 << 1);  //RE1̃rbg𔽓]
}

//ADϊʎ擾p荞
void __attribute__ ((__interrupt__,auto_psv)) _ADCInterrupt(void){
	//荞݃tONA
	IFS0bits.ADIF=0;
	IFS0bits.T3IF=0;

	//A/Dϊʊi[ϐ
	unsigned int result1, result2;

	//f[^o
	result1 = ADCBUF0;      //CH0(AN2)
	result2 = ADCBUF1;      //CH1(AN3)
	PR1 = 50 * ( FCY /1000 / 256 / 4) + result1 * 3;
	PR2 = 50 * ( FCY /1000 / 256 / 4) + result2 * 3;
}

//C
int main(void){
	//IO|[g̏ݒ
	TRISE = 0x0000;
	PORTE = 0x0000;

	//^C}1E荞ݐݒ
	PR1 = 100 * ( FCY /1000 / 256);    //^C}1ݒ
	T1CON = 0xA030;     //vXP[1:256
	IEC0bits.T1IE = 1;  //^C}1荞݋
	IPC0bits.T1IP = 5;  //^C}1D惌xݒ

	//^C}2E荞ݐݒ
	PR2 = 100 * ( FCY /1000 / 256);    //^C}2ݒ
	T2CON = 0xA030;     //vXP[1:256, 16rbg^C}
	IEC0bits.T2IE = 1;  //^C}2荞݋
	IPC1bits.T2IP = 5;  //^C}2D惌xݒ

	//^C}3E荞ݐݒ
	PR3 = 1000 * ( FCY /1000 / 256);    //^C}3̎ݒ
	T3CON = 0xA030;
	IEC0bits.T3IE = 1;  //^C}3荞݋
	IPC1bits.T3IP = 0;  //^C}3D惌xݒ

	//ADϊE荞ݐݒ
	ADCON1 = 0xA04C;
	/* ADCON1
	* ADCON, IDLEADC~, o͂͐f[^,
	* ^C}3AD荞, Tvgp, TvO
	*/
	ADCON2 = 0x0100;
	/* ADCON2
	* t@XVdd/Vss, XL͂Ȃ, CH0CH1ϊ,
	* 1ADCɊ荞, MUX Agp
	*/
	ADCON3 = 0x0110;
	/* ADCON3
	* Tv^C1Tad, VXeNbN, ϊNbN8Tcy
	*/
	ADCHS  = 0x0022;
	/* ADCHS
	* CH1~3͂̕Vref, CH1~3̐͂AN3~5(CH1AN3),
	* CH0͂̕Vref, CH0̐͂AN2
	*/
	ADPCFG = 0x0000;    //AN0~AN5͑SăAiO̓[h
	ADCSSL = 0x0000;    //̓XL͑SăXLbv
	IEC0bits.ADIE = 1;  //ADϊ荞݋
	IPC2bits.ADIP = 4;  //ADϊD惌xݒ

	SRbits.IPL = 2;     //CPU荞ݗD惌xݒ
	DISICNT = 0x0000;   //S荞݂
	while(1){
	}
	return 0;
}
