/*
* K5 𓚗
* UARTpĕoCg̃f[^肷vO
* {[[g2400
* dsPIC30F4012 @ 29.48MHz
*/

#define FCY 29480000 / 4    //NbN
#include <p30F4012.h>

// LCDsݒ
#define 	lcd_DataBit4	PORTDbits.RD0
#define 	lcd_DataBit5	PORTDbits.RD1
#define 	lcd_DataBit6	PORTCbits.RC13
#define 	lcd_DataBit7	PORTCbits.RC14
#define		lcd_e		PORTEbits.RE8	//EnableM̃sw
#define		lcd_rs		PORTCbits.RC15	//RSM̃sw
#include	<lcd_lib_dspic30F4012.c>

//RtBM[V
_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_ON & BORV20 & PWRT_OFF & MCLR_EN);
_FGS(CODE_PROT_OFF);

//vg^Cv錾
void __attribute__ ((__interrupt__,auto_psv)) _U1RXInterrupt(void);
void __attribute__ ((__interrupt__,auto_psv)) _U1TXInterrupt(void);

unsigned char rcv_data[3] = {0,0,0};     //UARTŎ󂯎l

//C
int main(void){
	//IO|[gݒ
	TRISC = 0x0000;
	PORTC = 0x0000;
	TRISD = 0x0000;
	PORTD = 0x0000;
	TRISE = 0x0000;
	PORTE = 0x0000;

	// LCD
	lcd_init();

	//UARTݒ
	U1BRG = 767;        //{[[gݒ(2400 @ 29.48MHz)
	U1MODE = 0x8000;
	/* U1MODE
	* UARTL, IDLEs, ʏsgp,
	* WakeUpELoopBackEAutoBaudE8bitpeBȂ, 1STOP
	*/
	U1STA = 0x8590;
	/* U1STA
	* Mobt@ɂȂƂ荞, Mu[Nݒʏ,
	* 3oCgMƂ荞, AhXo
	*/
	IPC2bits.U1RXIP = 5;    //M荞ݗDx5
	IPC2bits.U1TXIP = 3;    //M荞ݗDx3
	IEC0bits.U1RXIE = 1;    //M荞݋
	IEC0bits.U1TXIE = 1;    //M荞݋

	SRbits.IPL = 2;     //CPU荞ݗD惌xݒ
	DISICNT = 0x0000;   //S荞݂
	while(1){
		__delay_ms(500);
		U1TXREG = 12;  //Mf[^1oCg
		U1TXREG = 34;  //Mf[^2oCg
		U1TXREG = 56;  //Mf[^3oCg
	}
	return 0;
}

void __attribute__ ((__interrupt__,auto_psv)) _U1TXInterrupt(void){
	//荞݃tONA
	IFS0bits.U1TXIF = 0;
	while(U1STAbits.TRMT == 0){}    //M܂ő҂
}

void __attribute__ ((__interrupt__,auto_psv)) _U1RXInterrupt(void){
	//荞݃tONA
	IFS0bits.U1RXIF = 0;

	rcv_data[0] = U1RXREG;
	rcv_data[1] = U1RXREG;
	rcv_data[2] = U1RXREG;

	lcd_cur_home();
	lcd_num(rcv_data[0]);
	lcd_data(',');
	lcd_num(rcv_data[1]);
	lcd_data(',');
	lcd_num(rcv_data[2]);
}
